/**
* CB Chief main admin page JS script
*/

"use strict";

jQuery(function($) {
    $.fn.setDisabled = function(value) {
        if (typeof this['prop'] === 'function') {
            this.prop('disabled', value);
        } else if (value) {
            this.attr('disabled', 'disabled');
        } else {
            this.removeAttr('disabled');
        }

        if (value) {
            this.addClass('disabled');
        } else {
            this.removeClass('disabled');
        }

        return this;
    };

    $("#clickbank_category").change(function() {
        $("#clickbank_subcategory select").fadeOut("fast");
        $("#clickbank_subcategory_" + $(this).val()).fadeIn("fast");
    });
    if (typeof $['prop'] === 'function') {
        $("#clickbank_category").prop("disabled", false);
        $("#submit-button").prop("disabled", false);
    } else {
        $("#clickbank_category").attr("disabled", "");
        $("#submit-button").attr("disabled", "");
    }

    $('#publish_type-schedule').click(function() {
        $('#posts_per_week').removeAttr('disabled', 'disabled');
    });

    $('#publish_type-immediately').click(function() {
        $('#posts_per_week').attr('disabled', 'disabled');
    });

    $("#category-add-toggle").click(function(){
        $(this).parents("div:first").toggleClass("wp-hidden-children");

        $("#newcat").focus();
        return false;
    });

    $('#newcat').keypress(function() {
        if (13 == event.which) {
            event.preventDefault();
            $('#category-add-submit').click();
        }
    });

    $('.action-button').click(function() {
        $('#action').val($(this).attr('data-action'));
    });

    $('#select_items-all').click(function() {
        var value = 'checked' == $(this).attr('checked');
        $('.select_items').attr('checked', value? 'checked' : null);
        $(this).attr('title', value? 'Clear selection' : 'Select all');
    });

    $('#category-add-submit').click(function() {
        var $this = $(this);

        $('#category_add-ajax-response').hide();

        var newCat = $.trim($('#newcat').val());
        var parent = $('#newcat_parent').val();

        if ('' == newCat) {
            $('#category_add-ajax-response span').text('Please enter a category name');
            $('#category_add-ajax-response').show();
            $("#newcat").focus();

            return false;
        }

        $('#cbc-ajax_loading-category_add').css('visibility', 'visible');
        $this.setDisabled(true);

        //var data = {};

        $.ajax({
            type: 'POST',
            url: ajaxurl,
            data: {
                action:      'cbc',
                controller:  'admin',
                ajaxAction:  'add-category',
                parent:      parent,
                newCat:      newCat
            },
            dataType: 'json',
            success: function(data) {
                if ('' != data['error']) {
                    $('#category_add-ajax-response span').text('Error adding a category: ' + data['error']);
                    $('#category_add-ajax-response').show();
                } else {
                    var newCat = data['result']['label'];
                    var newCatSort = newCat.toLowerCase();
                    var prevLabel = '';
                    var curLabel = '';
                    var inserted = false;
                    var newId = data['result']['id'];
                    var newLi = $('<li id="category-' + newId + '" />')
                    .append($('<label class="selectit" />').text(' ' + newCat)
                        .prepend('<input value="' + newId + '" checked="checked" type="checkbox" name="post_category[]" id="in-category-' + newId + '">'));
                    var parentElement = parent > 0
                    ? $('#category-' + parent)
                    : $('#category-all');

                    if (parentElement.children('ul').length == 0) { // add ul, if not present
                        parentElement.append($(parent > 0? '<ul class="children" />' : '<ul id="categorychecklist" class="list:category categorychecklist form-no-clear" />')
                            .append(newLi));
                    } else { // cycle through items and compare cat name with existing cat names
                        $('ul', parentElement).first().children('li').each(function(n, elem) {
                            curLabel = $.trim($(elem).children('label:first').text()).toLowerCase();
                            if (newCatSort >= prevLabel && newCatSort < curLabel){
                                $(elem).before(newLi); // add li before
                                inserted = true;
                                return false;
                            }
                            prevLabel = curLabel;
                        });
                        if (!inserted) { // if no room to inserted, append to the end of the list
                            $('ul', parentElement).first().append(newLi);
                        }
                    }

                    var label = '';
                    var id = 0;
                    var level = 0;
                    $('#newcat_parent').empty();
                    $('#newcat_parent').append('<option value="-1">(parent category)</option>');
                    $('#categorychecklist').find('li').each(function(n, elem){
                        label = $.trim($(elem).children('label:first').text());
                        id = $(elem).children('label').children('input:first').val();
                        level = $(elem).parents('ul.children').length;
                        var pref = '';
                        for(var i = 0; i < level; i++) {
                            pref = pref + '&nbsp;&nbsp;&nbsp;';
                        }
                        $('#newcat_parent').append('<option class="level-' + level + '" value="' + id + '">' + pref + label + '</option>');

                    });

                    $('#in-category-' + newId).focus()

                    $("#newcat").val('');
                }
            },
            error: function() {
                $('#category_add-ajax-response span').text('AJAX request failed');
                $('#category_add-ajax-response').show();
            },
            complete: function() {
                $('#cbc-ajax_loading-category_add').css('visibility', 'hidden');
                $this.setDisabled(false);
            }
        });
    });

    function hasCredentials()
    {
        var result = true;
        $('#cbc-admin .cbc-clickbank-credential').each(function(){
            if ('' ==  $(this).val()) {
                result = false;
                return false;
            }
        });

        return result;
    }

    window.cbc_oldHasCredentials = hasCredentials();

    $('#cbc-admin .cbc-clickbank-credential').change(function() {
        var has = hasCredentials();
        if (window.cbc_oldHasCredentials == has || !has) {
            return;
        }

        $('#clickbank_category-ajax-response').hide();
        $('#clickbank_category-credential_notice').hide();

        $('#cbc-admin #clickbank_category')
        .empty()
        .setDisabled(true)
        .append('<option>loading...</option>');

        $.ajax({
            type: 'POST',
            url: ajaxurl,
            data: {
                action: 'cbc',
                controller: 'admin',
                ajaxAction: 'get-categories',
                data: $('#cbc-admin .cbc-clickbank-credential').serialize()
            },
            dataType: 'json',
            success: function(response) {
                if (response && 'undefined' == typeof(response.error)) {
                    $('#cbc-admin #clickbank_category')
                    .empty()
                    .setDisabled(false)
                    .append('<option value="0">(any)</option>')
                    .append(response.categories);

                    $('#clickbank_subcategory').append(response.subcategories);

                    window.cbc_oldHasCredentials = true;

                } else {
                    $('#clickbank_category-ajax-response span').text(response.error);
                    $('#clickbank_category-ajax-response').show();
                    $('#clickbank_category-credential_notice').show();

                    $('#cbc-admin #clickbank_category')
                    .empty()
                    .setDisabled(true)
                    .append('<option value="0">(any)</option>');
                }
            },
            error: function(xhr, ajaxOptions, thrownError){
                $('#clickbank_category-ajax-response span').text('AJAX request failed');
                $('#clickbank_category-ajax-response').show();
                $('#clickbank_category-credential_notice').show();

                $('#cbc-admin #clickbank_category')
                .empty()
                .setDisabled(true)
                .append('<option>(any)</option>');
            },
            complete: function(){
            }
        });
    });
});