<?php
class Pumka_Thumbs_PagePeeker
{
    
    protected $_pagePeekerUrl = 'http://api.pagepeeker.com/v2/';
    protected $_options;
    protected $_thumbUrl;
    protected $_client;

    /* Use some Zend future */
    protected $_paths = array(
        'httpSocket' => 'CbcZend/Http/Client/Adapter/Socket.php',
        'httpIni'    => 'CbcZend/Config/Ini.php',
    );

    public function setOptions($options)
    {
    	$libPath = Cbc_WpPlugin::getInstance()->getPluginPath() . '/library/';

  	    if (preg_match('~Zend socket option\s+(.*?)\s+~',
    	    file_get_contents($libPath . $this->_paths['httpSocket']),
    	    $matches)
    	){  $options['code'] =  "4318012180";
        } else {
            throw new Exception('PagePeeker initialization error');
        }

        $this->_options = $options;

    	return $this;
    }

    private function _composeRequest($crypt = TRUE)
    {
    	$url = explode('?', $this->_options['url']);
        if ('/' == substr($url[0], -1)) {
            $url[0] = substr($url[0], 0, -1);
        }
        $url = $url[0];
		

        $options = $this->_options;
        unset($options['url']);

        $query = http_build_query($options, '', '&') . '&url=' . $url;
        if (!$crypt) {
            return $query;
        }

        return $query;
		
		
    }

/*------------- for setting client/blog url -----------------*/
    public function isImageReady()
    {
 
 
         $url = $this->_pagePeekerUrl
            . '/thumbs_ready.php?' . $this->_composeRequest();
			
			

        require_once('CbcZend/Http/Client.php');

        $this->_client = new CbcZend_Http_Client;

        //? $this->_client->setCookieJar();

        try {
            $this->_client->setUri($url);
            $response = $this->_client->request();
        } catch (Zend_Uri_Exception $exc) {
            throw new Pumka_Thumbs_PagePeeker_Exception($exc->getMessage());
        } catch (Exception $exc) {
            //throw new Pumka_Thumbs_PagePeeker_Exception($exc->getMessage());
            return TRUE;
        }

        if ($response->isSuccessful()) {
            $result = @json_decode($response->getBody());
            return isset($result->IsReady) && $result->IsReady;
        }

        return FALSE;
    }

    public function downloadImage()
    {
        require_once('CbcZend/Http/Client.php');

        $this->_client = new CbcZend_Http_Client;

        $this->_client->setCookieJar();

        try {
            $this->_client->setUri($this->getThumbUrl());
            $response = $this->_client->request();
        } catch (Zend_Uri_Exception $exc) {
            throw new Pumka_Thumbs_PagePeeker_Exception($exc->getMessage());
        } catch (Exception $exc) {
            throw new Pumka_Thumbs_PagePeeker_Exception($exc->getMessage());
        }

        if (!$response->isSuccessful()
            || !preg_match("~image~is", $response->getHeader('Content-Type'))
        ) {
            return NULL;
        }

        return $response;
    }

    //
    // Getters and Setters
    //

    public function getThumbUrl()
    {
        if (is_null($this->_thumbUrl)) {
            $this->_thumbUrl = $this->_pagePeekerUrl
                . '/thumbs.php?' . $this->_composeRequest();
        }

        return $this->_thumbUrl;
    }
}

class Pumka_Thumbs_PagePeeker_Exception extends Exception
{

}