<?php
require_once CBC_WPMODULE_PATH . '/controllers/Abstract/Ajax.php';

class Cbc_WpModule_Controller_AdminAjaxController
    extends Cbc_WpModule_Controller_Abstract_Ajax
{

    public function addCategoryAction()
    {
        $this->setViewScript(NULL);

        $result = array();
        $error = '';

        $parent = null;;
        if (isset($_POST['parent'])) {
            $parent = $_POST['parent'];
        }

        if (!isset($_POST['newCat']) || ('' == $_POST['newCat'])) {
            $error = "Category name is required";

        } else {
            $newCat = $_POST['newCat'];

            $res = wp_insert_category(
                array(
                    'cat_name' => $newCat,
                    'category_parent' => $parent,
                ),
                TRUE
            );

           if (is_wp_error($res)) {
               $error = $res->get_error_message();
           } else {
               $category = get_category($res);
               if ($category) {
                   $result['id'] = $category->term_id;
                   $result['label'] = $category->name;
               } else {
                   $error = 'Unknown error';
               }
           }
        }

        header('Content-Type: application/json', TRUE);
        echo json_encode(array(
            'error' => $error,
            'result' => $result,
        ));
    }

    public function getCategoriesAction()
    {
        $this->setViewScript(NULL);

        $result = array();

        try {
            if (!isset($_POST['data'])) {
                $this->_throwError('Data parameter not found');
            }

            parse_str($_POST['data'], $data);

            if (isset($data['clickbank_password'])) {
                $data['clickbank_password'] = stripslashes(stripslashes($data['clickbank_password']));
            }

            try {
                $this->_view->categories = Cbc_WpModule_Application::getModel('CoreApp')
                    ->getCategories($data);
            } catch (Cbc_WpModule_Model_CoreAppException $e) {
                $this->_throwError($e->getMessage());
            }

            $result['categories'] = $this->_view->render('admin-ajax/categories.phtml');
            $result['subcategories'] = $this->_view->render('admin-ajax/subcategories.phtml');

        } catch (Cbc_WpModule_Controller_AdminAjaxController_Exception $e) {
            $result['error'] = $e->getMessage();
        }

        header('Content-Type: application/json', TRUE);
        echo json_encode($result);
    }

    protected function _throwError($msg)
    {
        throw new Cbc_WpModule_Controller_AdminAjaxController_Exception($msg);
    }
}

class Cbc_WpModule_Controller_AdminAjaxController_Exception
    extends Exception
{

}