<?php
class Cbc_WpModule_Model_TransientOptions
{
    const PREFIX = Cbc_WpPlugin::PREFIX;

    public function getValue($name, $default=NULL)
    {
         $result = get_transient(self::PREFIX . '_' . $name);
         if ('' == $result) {
             $result = $default;
         }

         return $result;
    }

    public function setValue($name, $value, $expiration)
    {
        set_transient(self::PREFIX . '_' . $name, $value, $expiration);

        return $this;
    }

    public function unsetValue($name)
    {
        delete_transient(self::PREFIX . '_' . $name);

        return $this;
    }

    public function cleanStaleByPrefix($prefix)
    {
        global $wpdb;

        $prefix = Cct_WpPlugin::PREFIX . '_' . $prefix;
        $now = time();

        $wpdb->query("DELETE v, t
            FROM `{$wpdb->options}` v, `{$wpdb->options}` t
            WHERE v.`option_name` LIKE '_transient_{$prefix}_%'
                AND t.`option_name` = REPLACE(v.`option_name`, '_transient_', '_transient_timeout_')
                AND t.`option_value` < {$now}"
            );

        return $this;
    }
}
